Subject: [bug#41871] [PATCH 0/7] IcedTea: Build (efficiently) on aarch64-linux

From: Efraim Flashner <[email-masked]>
Date: Mon, 2 Nov 2020 11:54:05 +0200

On Wed, Oct 28, 2020 at 10:35:08AM -0400, Simon South wrote:
> Efraim Flashner <[email-masked]> writes:
> > On Mon, Sep 14, 2020 at 03:24:15PM +0200, Ricardo Wurmus wrote:
> >> This looks really great!  I have yet to read the patches in 41748 and
> >> 41648, but these patches here look good to me...
> >
> > I had this on my TODO list for a while and I seem to have forgotten
> > about it. Since at least one of the patches was applied to staging I'm
> > testing them on staging now. Assuming no problems on x86_64 and aarch64
> > I'll go ahead and push them.
> 
> Wonderful. Thank you both for looking at these changes.
> 
> If they're able to be applied in time, it'll be possible to list
> "Support for Java applications on aarch64-linux" among the new features
> in Guix 1.2.0.
> 

I'm still running into trouble building icedtea@2 on aarch64 on staging
so I've locally applied the patches on master and I'll test it out
there.

The error message, in case anyone wants to try to work at it
specifically:

/tmp/guix-build-icedtea-2.6.13.drv-0/icedtea-2.6.13/bootstrap/jdk1.6.0/bin/java -XX:-PrintVMOptions -XX:+UnlockDiagnosticVMOptions -XX:-LogVMOutput -Xmx512m -Xms512m -XX:PermSize=32m -XX:MaxPermSize=160m -Xbootclasspath/p:/tmp/guix-build-icedtea-2.6.13.drv-0/icedtea-2.6.13/openjdk.build-boot/langtools/dist/bootstrap/lib/javac.jar -jar /tmp/guix-build-icedtea-2.6.13.drv-0/icedtea-2.6.13/openjdk.build-boot/langtools/dist/bootstrap/lib/javac.jar -g -Xlint:-path -source 6 -target 6 -encoding ascii -Xbootclasspath:/tmp/guix-build-icedtea-2.6.13.drv-0/icedtea-2.6.13/openjdk.build-boot/classes -sourcepath /tmp/guix-build-icedtea-2.6.13.drv-0/icedtea-2.6.13/generated.build:../../../src/solaris/classes:../../../src/share/classes -d /tmp/guix-build-icedtea-2.6.13.drv-0/icedtea-2.6.13/openjdk.build-boot/classes @/tmp/guix-build-icedtea-2.6.13.drv-0/icedtea-2.6.13/openjdk.build-boot/tmp/java/java.lang/java/.classes.list.filtered
../../../src/share/classes/java/lang/invoke/MethodHandle.java:463: error: MethodHandle API building requires -target 7 runtimes or better; current is -target 1.6
    public final native @PolymorphicSignature Object invokeExact(Object... args) throws Throwable;
                                                     ^
../../../src/share/classes/java/lang/invoke/MethodHandle.java:498: error: MethodHandle API building requires -target 7 runtimes or better; current is -target 1.6
    public final native @PolymorphicSignature Object invoke(Object... args) throws Throwable;
                                                     ^
../../../src/share/classes/java/lang/invoke/MethodHandle.java:515: error: MethodHandle API building requires -target 7 runtimes or better; current is -target 1.6
    /*non-public*/ final native @PolymorphicSignature Object invokeBasic(Object... args) throws Throwable;
                                                             ^
../../../src/share/classes/java/lang/invoke/MethodHandle.java:517: error: MethodHandle API building requires -target 7 runtimes or better; current is -target 1.6
    /*non-public*/ static native @PolymorphicSignature Object linkToVirtual(Object... args) throws Throwable;
                                                              ^
../../../src/share/classes/java/lang/invoke/MethodHandle.java:524: error: MethodHandle API building requires -target 7 runtimes or better; current is -target 1.6
    /*non-public*/ static native @PolymorphicSignature Object linkToStatic(Object... args) throws Throwable;
                                                              ^
../../../src/share/classes/java/lang/invoke/MethodHandle.java:531: error: MethodHandle API building requires -target 7 runtimes or better; current is -target 1.6
    /*non-public*/ static native @PolymorphicSignature Object linkToSpecial(Object... args) throws Throwable;
                                                              ^
../../../src/share/classes/java/lang/invoke/MethodHandle.java:538: error: MethodHandle API building requires -target 7 runtimes or better; current is -target 1.6
    /*non-public*/ static native @PolymorphicSignature Object linkToInterface(Object... args) throws Throwable;
                                                              ^
Note: Some input files use or override a deprecated API.
Note: Recompile with -Xlint:deprecation for details.
Note: Some input files use unchecked or unsafe operations.
Note: Recompile with -Xlint:unchecked for details.
7 errors
make[5]: *** [/tmp/guix-build-icedtea-2.6.13.drv-0/icedtea-2.6.13/openjdk-boot/jdk/make/common/Rules.gmk:254: .compile.classlist] Error 1
make[5]: Leaving directory '/tmp/guix-build-icedtea-2.6.13.drv-0/icedtea-2.6.13/openjdk-boot/jdk/make/java/java'
make[4]: *** [Makefile:63: all] Error 1
make[4]: Leaving directory '/tmp/guix-build-icedtea-2.6.13.drv-0/icedtea-2.6.13/openjdk-boot/jdk/make/java'
make[3]: *** [Makefile:253: all] Error 1
make[3]: Leaving directory '/tmp/guix-build-icedtea-2.6.13.drv-0/icedtea-2.6.13/openjdk-boot/jdk/make'
make[2]: *** [make/jdk-rules.gmk:93: jdk-build] Error 2
make[2]: Leaving directory '/tmp/guix-build-icedtea-2.6.13.drv-0/icedtea-2.6.13/openjdk-boot'
make[1]: *** [Makefile:251: build_product_image] Error 2
make[1]: Leaving directory '/tmp/guix-build-icedtea-2.6.13.drv-0/icedtea-2.6.13/openjdk-boot'
make: *** [Makefile:2741: stamps/icedtea-boot.stamp] Error 2
command "make" "-j" "2" failed with status 2
builder for `/gnu/store/n9p75jv705bdf0983xrbw5142fw1fp7z-icedtea-2.6.13.drv' failed with exit code 1
@ build-failed /gnu/store/n9p75jv705bdf0983xrbw5142fw1fp7z-icedtea-2.6.13.drv - 1 builder for `/gnu/store/n9p75jv705bdf0983xrbw5142fw1fp7z-icedtea-2.6.13.drv' failed with exit code 1
derivation '/gnu/store/n9p75jv705bdf0983xrbw5142fw1fp7z-icedtea-2.6.13.drv' offloaded to 'pine64' failed: build of `/gnu/store/n9p75jv705bdf0983xrbw5142fw1fp7z-icedtea-2.6.13.drv' failed
build of /gnu/store/n9p75jv705bdf0983xrbw5142fw1fp7z-icedtea-2.6.13.drv failed

-- 
Efraim Flashner   <[email-masked]>   אפרים פלשנר
GPG key = A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
Confidentiality cannot be guaranteed on emails sent or received unencrypted